/**
 * Copyright 2019 DH
 * All right reserved.
 * 项目名称: 大恒泰山系统
 * 创建日期:2022/8/22
 */
package org.springblade.modules.baseinfo.project.wrapper;

import org.springblade.common.cache.DictBizCache;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.modules.baseinfo.project.entity.ProjectInfoEntity;
import org.springblade.modules.baseinfo.project.vo.ProjectInfoVO;
import org.springblade.modules.baseinfo.region.entity.RegionInfoEntity;
import org.springblade.modules.baseinfo.region.service.IBaseRegionService;
import org.springblade.modules.system.entity.DictBiz;

import java.util.List;
import java.util.Objects;

/***
 * Date:2022/8/22
 * Title:文件所属模块（必须填写）
 * Description：对本文件的详细描述，原则上不能少于30字
 * @author dylan
 * @version 1.0
 * Remark：认为有必要的其他信息
 */
public class ProjectInfoWrapper extends BaseEntityWrapper<ProjectInfoEntity, ProjectInfoVO> {
    public static ProjectInfoWrapper build() {
        return new ProjectInfoWrapper();
    }

    private static IBaseRegionService baseInfoRegionService;

    private static IBaseRegionService getBaseRegionService() {
        if (baseInfoRegionService == null) {
            baseInfoRegionService = SpringUtil.getBean(IBaseRegionService.class);
        }
        return baseInfoRegionService;
    }

    @Override
    public ProjectInfoVO entityVO(ProjectInfoEntity entity) {
        ProjectInfoVO projectInfoVO = Objects.requireNonNull(BeanUtil.copy(entity, ProjectInfoVO.class));
        return this.entityVO(projectInfoVO);
    }

    public ProjectInfoVO entityVO(ProjectInfoVO vo) {
        if (vo.getAdcd() != null) {
            String[] adcds = vo.getAdcd().split(",");
            StringBuilder adName = new StringBuilder();
            for (int i = 0; i < adcds.length; i++) {
                RegionInfoEntity entity = getBaseRegionService().getByCode(adcds[i]);
                if (adName.length() > 0) {
                    adName.append("/");
                }
                adName.append(entity.getAdnm());
            }
            vo.setAdName(adName.toString());
        }
        return vo;
    }
}
